/*	
 *	app.h
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

/* Windows */
#define STRICT
#include <windows.h>
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")
/* P/ECE(USBCOM) */
#include "pieceif.h"
#pragma comment(lib, "pieceif.lib")
/* WCCu */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

/* 64bit^̒` */
#ifdef WIN32
typedef          __int64	 int64;
typedef unsigned __int64	uint64;
#else
typedef          long long	uint64;
typedef unsigned long long	uint64;
#endif

#define APPNAME	"P/EMU"
#define VERSION	"20030423"

/* /usr/PIECE/include/piece.hc */
typedef struct tagSYSTEMINFO {		// (piece.h)
	unsigned short size;		//  0 ̍\̂̃TCY
	unsigned short hard_ver;	//  2 n[hEGAEo[W
	unsigned short bios_ver;	//  4 BIOSo[W
	unsigned short bios_date;	//  6 BIOSXV YY(7):MM(4):DD(5)
	unsigned long sys_clock;	//  8 VXeENbN(Hz)
	unsigned short vdde_voltage;	// 12 VDDE()d(mV)
	unsigned short resv1;		// 14 \
	unsigned char *sram_top;	// 16 SRAM JnAhX
	unsigned char *sram_end;	// 20 SRAM IAhX+1
	unsigned char *pffs_top;	// 24 pffs JnAhX
	unsigned char *pffs_end;	// 28 pffs IAhX
} SYSTEMINFO;

#include "emu.h"
//
#include "fram.h"
#include "iomem.h"
#include "sram.h"
#include "usbc.h"
#include "flash.h"
#include "lcdc.h"
//
#include "bcu.h"
#include "core.h"
//
#include "c33209e.h"
#include "vector.h"
#include "iomap.h"

/* main.c */
extern HINSTANCE hinst;				/* CX^Xnh */
extern HWND hwnd;				/* CEChE */
extern unsigned char keystate[256];		/* L[ */
extern unsigned char vbuff[DISP_Y][DISP_X];	/* zVRAM */
//
void dbg(const char* fmt, ...);
void die(const char* fmt, ...);
#define DIE()	die(__FILE__ "(%d)", __LINE__)

#define KEY_UP		VK_UP
#define KEY_DOWN	VK_DOWN
#define KEY_LEFT	VK_LEFT
#define KEY_RIGHT	VK_RIGHT
#define KEY_A		'Z'
#define KEY_B		'X'
#define KEY_START	'A'
#define KEY_SELECT	'S'

#endif /*__APP_H__*/
