/*	
 *	bcu.c
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 *	* Wed Apr 22 05:21:00 JST 2003 Naoyuki Sawa
 *	- DMÃANZXpɁAmem_read_nowait()/mem_write_nowait()ǉB
 *	  ܂ŁADMÃANZXCLKZĂ̂C܂B
 */
#include "app.h"

/****************************************************************************
 *	GA`
 ****************************************************************************/

typedef struct _AREA {
	unsigned addr;
	int (*read)(unsigned ofs, int size);
	void (*write)(unsigned ofs, int data, int size);
} AREA;
static AREA area_tbl[] = {
/* 0*/	{	0x0000000,	fram_read,	fram_write	},
/* 1*/	{	0x0030000,	iomem_read,	iomem_write	},
/* 2*/	{	0x0060000,	NULL,		NULL		},
/* 3*/	{	0x0080000,	NULL,		NULL		},
/* 4*/	{	0x0100000,	sram_read,	sram_write	},
/* 5*/	{	0x0200000,	NULL,		NULL		},
/* 6*/	{	0x0300000,	NULL,		NULL		},
/* 7*/	{	0x0400000,	usbc_read,	usbc_write	},
/* 8*/	{	0x0600000,	NULL,		NULL		},
/* 9*/	{	0x0800000,	NULL,		NULL		},
/*10*/	{	0x0c00000,	flash_read,	flash_write	},
/*11*/	{	0x1000000,	NULL,		NULL		},
/*12*/	{	0x1800000,	NULL,		NULL		},
/*13*/	{	0x2000000,	NULL,		NULL		},
/*14*/	{	0x3000000,	NULL,		NULL		},
/*15*/	{	0x4000000,	NULL,		NULL		},
/*16*/	{	0x6000000,	NULL,		NULL		},
/*17*/	{	0x8000000,	NULL,		NULL		},
/*18*/	{	0xc000000,	NULL,		NULL		},
};
#define AREA_COUNT	(sizeof area_tbl / sizeof *area_tbl)

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

void
bcu_init()
{
	/* TODO */
}

static AREA*
area_sel(unsigned addr, int size, int wait/*0:EFCgZȂ/1:*/)
{
	int i, sz, wt;
	AREA* area;

	/* `FbNB */
	switch(size) {
	case 1:                     break;
	case 2: if(addr & 1) DIE(); break;
	case 4: if(addr & 3) DIE(); break;
	default: DIE();
	}

	/* GAIB */
	addr &= (1 << 28) - 1; /* S1C33̃AhXԂ28rbg */
	for(i = 0, area = area_tbl; i < AREA_COUNT - 1/*dv*/; i++, area++) {
		if(addr < (area + 1)->addr) break;
	}

	/* EFCgZB */
	if(!wait) goto NO_WAIT;
	switch(i) {
	case 18:
	case 17:
		sz = bA18_15_A18SZ;
		wt = bA18_15_A18WT;
		break;
	case 16:
	case 15:
		sz = bA18_15_A16SZ;
		wt = bA18_15_A16WT;
		break;
	case 14:
	case 13:
		sz = bA14_13_A14SZ;
		wt = bA14_13_A14WT;
		break;
	case 12:
	case 11:
		sz = bA12_11_A12SZ;
		wt = bA12_11_A12WT;
		break;
	case 10:
	case  9:
		sz = bA10_9_A10SZ;
		wt = bA10_9_A10WT;
		break;
	case  8:
	case  7:
		sz = bA8_7_A8SZ;
		wt = bA8_7_A8WT;
		break;
	case  6:
	case  5:
	case  4:
		sz = bA6_4_A5SZ;
		wt = bA6_4_A5WT;
		break;
	default:
		goto NO_WAIT;
	}
	if(sz) { /*  8rbgfoCX */
		switch(size) {
		case 1: CLK += wt * 1; break;
		case 2: CLK += wt * 2; break;
		case 4: CLK += wt * 4; break;
		default:
			DIE();
		}
	} else { /* 16rbgfoCX */
		switch(size) {
		case 1: CLK += wt * 1; break;
		case 2: CLK += wt * 1; break;
		case 4: CLK += wt * 2; break;
		default:
			DIE();
		}
	}
	/* RAMȊOւ̃ANZX́Ä̗̃EFCgTCNɉāA1TCNKvłB
	 * iS1C33000RACPU}jA 33000Core-J.pdf p.34u3.2.2 ߂̎sTCN (2)vQƁj
	 */
	CLK += 1;
NO_WAIT:

	return area;
}

int
mem_read(unsigned addr, int size)
{
	AREA* area = area_sel(addr, size, 1/*EFCgZ*/);
	if(!area->read) return -1;
	return area->read(addr - area->addr, size);
}

void
mem_write(unsigned addr, int data, int size)
{
	AREA* area = area_sel(addr, size, 1/*EFCgZ*/);
	if(!area->write) return;
	area->write(addr - area->addr, data, size);
}

int
mem_read_nowait(unsigned addr, int size)
{
	AREA* area = area_sel(addr, size, 0/*EFCgZȂ*/);
	if(!area->read) return -1;
	return area->read(addr - area->addr, size);
}

void
mem_write_nowait(unsigned addr, int data, int size)
{
	AREA* area = area_sel(addr, size, 0/*EFCgZȂ*/);
	if(!area->write) return;
	area->write(addr - area->addr, data, size);
}

