/*	
 *	core.c
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sat Apr 19 12:30:00 JST 2003 Naoyuki Sawa
 *	- scan0/scan1̃oOCBitłj
 */
#include "app.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

CORE core;

/****************************************************************************
 *	}NE⏕֐
 ****************************************************************************/

/* ֐̐擪Ŏg悤ɁA_~[ϐ܂B */
static int no_ext()	{ if(EXT1.s) DIE(); return 0; }
static int no_delay()	{ if(core.d) DIE(); return 0; }
#define NO_EXT		int __no_ext__ = no_ext()
#define NO_DELAY	int __no_delay__ = no_delay()

/* CfNXt̔ėp/VXeWX^ANZX@*/
static int check_r(int n) { if(n < 0 || n > 15) DIE(); return n; }
static int check_s(int n) { if(n < 0 || n >  3) DIE(); return n; }
#define R(n)	core.r[check_r(n)]
#define S(n)	core.s[check_s(n)]

/* ldatãrbg(bits-1)Arbg31`bitsɕg܂B */
static int
sign_ext(int data, int bits)
{
	data <<= 32 - bits;
	data >>= 32 - bits;
	return data;
}

/* fBCh򖽗߂̒gpBd1w肳ꂽAfBCh߂s܂B */
static void
exec_delay(int d)
{
	INST inst;
	if(d) {
		if(core.d) DIE();	/* Ô߁AfBChdɂȂĂȂƂ */
		core.d = 1;		/* fBChJn */
		inst.s = mem_read(PC + 2, 2);
		core_inst(inst);
		if(!core.d) DIE();	/* Ô߁A\ȂfBChȂƂ */
		core.d = 0;		/* fBChI */
	}
}

/****************************************************************************
 *	lg
 ****************************************************************************/

static int
ext_imm6(int imm6)
{
	int data;
	imm6 &= (1 << 6) - 1;
	if(EXT2.s) {
		data = imm6 | (EXT2.c6.imm13 << 6) | (EXT1.c6.imm13 << 19);
	} else if(EXT1.s) {
		data = imm6 | (EXT1.c6.imm13 << 6);
	} else {
		data = imm6;
	}
	memset(core.ext, 0, sizeof core.ext);
	return data;
}

static int
ext_sign6(int sign6)
{
	int data, bits;
	sign6 &= (1 << 6) - 1;
	if(EXT2.s) {
		data = sign6 | (EXT2.c6.imm13 << 6) | (EXT1.c6.imm13 << 19);
		bits = 6 + 13 + 13;
	} else if(EXT1.s) {
		data = sign6 | (EXT1.c6.imm13 << 6);
		bits = 6 + 13;
	} else {
		data = sign6;
		bits = 6;
	}
	memset(core.ext, 0, sizeof core.ext);
	return sign_ext(data, bits);
}

static int
ext_RB(int rb)
{
	int disp;
	if(EXT2.s) {
		disp = (EXT2.c6.imm13 << 0) | (EXT1.c6.imm13 << 13);
	} else if(EXT1.s) {
		disp = (EXT1.c6.imm13 << 0);
	} else {
		disp = 0;
	}
	memset(core.ext, 0, sizeof core.ext);
	return R(rb) + disp;
}

static int
ext_SPxIMM6(int imm6, int size)
{
	int disp;
	imm6 &= (1 << 6) - 1;
	if(EXT2.s) {
		disp = imm6 | (EXT2.c6.imm13 << 6) | (EXT1.c6.imm13 << 19);
	} else if(EXT1.s) {
		disp = imm6 | (EXT1.c6.imm13 << 6);
	} else {
		switch(size) {
		case 1: disp = imm6 * 1; break;
		case 2: disp = imm6 * 2; break;
		case 4: disp = imm6 * 4; break;
		default: DIE();
		}
	}
	memset(core.ext, 0, sizeof core.ext);
	return SP + disp;
}

static int
ext_3op()
{
	/* NOTE1: ȂƂEXT1݂邱ƂĂяoŊmFĂB */
	/* NOTE2: cmp/and/or/xor/notA3opgsignł͂ȂimmƂȂ܂B */
	int data;
	if(EXT2.s) {
		data = (EXT2.c6.imm13 << 0) | (EXT1.c6.imm13 << 13);
	} else if(EXT1.s) {
		data = (EXT1.c6.imm13 << 0);
	} else {
		DIE();
	}
	memset(core.ext, 0, sizeof core.ext);
	return data;
}

static int
ext_PCxSIGN8(int sign8)
{
	int disp, bits;
	sign8 &= (1 << 8) - 1;
	if(EXT2.s) {
		disp = sign8 | (EXT2.c6.imm13 << 8) | (EXT1.c6.imm13 >> 3 << 21);
		bits = 8 + 13 + 10;
	} else if(EXT1.s) {
		disp = sign8 | (EXT1.c6.imm13 << 8);
		bits = 8 + 13;
	} else {
		disp = sign8;
		bits = 8;
	}
	memset(core.ext, 0, sizeof core.ext);
	return PC + sign_ext(disp, bits) * 2;
}

/****************************************************************************
 *	ʉZPSRݒ
 ****************************************************************************/

static int
add(int a, int b)
{
	int c = a + b;
	PSR.n = c < 0;
	PSR.z = !c;
	PSR.v = (a < 0  && b <  0 && c >= 0) ||
	        (a >= 0 && b >= 0 && c <  0);
	PSR.c = (unsigned)c < (unsigned)a;
	return c;
}

static int
adc(int a, int b)
{
	int c = a + b;
	int d = c + PSR.c;
	PSR.n = d < 0;
	PSR.z = !d;
	PSR.v = (a < 0  && b <  0 && d >= 0) ||
		(a >= 0 && b >= 0 && d <  0);
	PSR.c = ((unsigned)c < (unsigned)a) ||
		((unsigned)d < (unsigned)c);
	return d;
}

static int
sub(int a, int b)
{
	int c = a - b;
	PSR.n = c < 0;
	PSR.z = !c;
	PSR.v = (a >= 0 && b <  0 && c <  0) ||
	        (a <  0 && b >= 0 && c >= 0);
	PSR.c = (unsigned)c > (unsigned)a;
	return c;
}

static int
sbc(int a, int b)
{
	int c = a - b;
	int d = c - PSR.c;
	PSR.n = d < 0;
	PSR.z = !d;
	PSR.v = (a >= 0 && b <  0 && d <  0) ||
	        (a <  0 && b >= 0 && d >= 0);
	PSR.c = ((unsigned)c > (unsigned)a) ||
		((unsigned)d > (unsigned)c);
	return d;
}

static int
and(int a, int b)
{
	a &= b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
or(int a, int b)
{
	a |= b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
xor(int a, int b)
{
	a ^= b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
not(int a)
{
	a = ~a;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
srl(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = (unsigned)a >> b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
sll(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = (unsigned)a << b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
sra(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = (int)a >> b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
sla(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = (int)a << b;
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
rr(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = ((unsigned)a >> b) | ((unsigned)a << (32 - b));
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

static int
rl(int a, int b)
{
	if(b < 0 || b > 8) DIE();
	a = ((unsigned)a << b) | ((unsigned)a >> (32 - b));
	PSR.n = a < 0;
	PSR.z = !a;
	return a;
}

/****************************************************************************
 *	CLASS 0A
 ****************************************************************************/

static void exec_nop(CLASS_0A inst) { NO_EXT; NO_DELAY;
	PC += 2;
	CLK += 1;
}
static void exec_slp(CLASS_0A inst) { NO_EXT; NO_DELAY;
	/* TODO: */
	PC += 2;
	CLK += 1;
}
static void exec_halt(CLASS_0A inst) { NO_EXT; NO_DELAY;
	/* TODO: */
	PC += 2;
	CLK += 1;
}
static void exec_pushn_rs(CLASS_0A inst) { NO_EXT; NO_DELAY;
	int rs;
	for(rs = inst.imm2_rd_rs; rs >= 0; rs--) {
		SP -= 4;
		mem_write(SP, R(rs), 4);
		CLK += 1;
	}
	PC += 2;
}
static void exec_popn_rd(CLASS_0A inst) { NO_EXT; NO_DELAY;
	int rd;
	for(rd = 0; rd <= inst.imm2_rd_rs; rd++) {
		R(rd) = mem_read(SP, 4);
		SP += 4;
		CLK += 1;
	}
	PC += 2;
}
static void exec_brk(CLASS_0A inst) { DIE(); }
static void exec_retd(CLASS_0A inst) { DIE(); }
static void exec_int_imm2(CLASS_0A inst) { NO_EXT; NO_DELAY;
	if(inst.imm2_rd_rs < 0 || inst.imm2_rd_rs > 3) DIE();
	PC += 2;
	CLK += 10;
	core_trap(TRAP_SOFTINT0 + inst.imm2_rd_rs, 0);
}
static void exec_reti(CLASS_0A inst) { NO_EXT; NO_DELAY;
	S(0) = mem_read(SP, 4);
	SP += 4;
	PC = mem_read(SP, 4);
	SP += 4;
	CLK += 5;
}
static void exec_call_rb(CLASS_0A inst) { NO_EXT; NO_DELAY;
	unsigned addr = R(inst.imm2_rd_rs);
	exec_delay(inst.d);
	SP -= 4;
	mem_write(SP, PC + 2, 4);
	PC = addr;
	CLK += !inst.d ? 3 : 2;
}
static void exec_ret(CLASS_0A inst) { NO_EXT; NO_DELAY;
	unsigned addr = mem_read(SP, 4);
	SP += 4;
	exec_delay(inst.d);
	PC = addr;
	CLK += !inst.d ? 4 : 3;
}
static void exec_jp_rb(CLASS_0A inst) { NO_EXT; NO_DELAY;
	unsigned addr = R(inst.imm2_rd_rs);
	exec_delay(inst.d);
	PC = addr;
	CLK += !inst.d ? 2 : 1;
}

/****************************************************************************
 *	CLASS 0B
 ****************************************************************************/

static void exec_jrgt_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = !(PSR.n ^ PSR.v) && !PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrge_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = !(PSR.n ^ PSR.v);
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrlt_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = (PSR.n ^ PSR.v);
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrle_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = (PSR.n ^ PSR.v) || PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrugt_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = !PSR.c && !PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jruge_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = !PSR.c;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrult_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = PSR.c;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrule_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = PSR.c || PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jreq_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_jrne_sign8(CLASS_0B inst) { NO_DELAY;
	int cc = !PSR.z;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = cc ? addr : PC + 2;
	CLK += cc && !inst.d ? 2 : 1;
}
static void exec_call_sign8(CLASS_0B inst) { NO_DELAY;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	SP -= 4;
	mem_write(SP, PC + 2, 4);
	PC = addr;
	CLK += !inst.d ? 3 : 2;
}
static void exec_jp_sign8(CLASS_0B inst) { NO_DELAY;
	unsigned addr = ext_PCxSIGN8(inst.sign8);
	exec_delay(inst.d);
	PC = addr;
	CLK += !inst.d ? 2 : 1;
}

/****************************************************************************
 *	CLASS 1A
 ****************************************************************************/

static void exec_ld_b_rd_RB(CLASS_1A inst) { NO_DELAY;
	R(inst.rs_rd) = (char)mem_read(ext_RB(inst.rb), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_ub_rd_RB(CLASS_1A inst) { NO_DELAY;
	R(inst.rs_rd) = (unsigned char)mem_read(ext_RB(inst.rb), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_h_rd_RB(CLASS_1A inst) { NO_DELAY;
	R(inst.rs_rd) = (short)mem_read(ext_RB(inst.rb), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_uh_rd_RB(CLASS_1A inst) { NO_DELAY;
	R(inst.rs_rd) = (unsigned short)mem_read(ext_RB(inst.rb), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_rd_RB(CLASS_1A inst) { NO_DELAY;
	R(inst.rs_rd) = mem_read(ext_RB(inst.rb), 4);
	PC += 2;
	CLK += 1;
}
static void exec_ld_b_RB_rs(CLASS_1A inst) { NO_DELAY;
	mem_write(ext_RB(inst.rb), R(inst.rs_rd), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_h_RB_rs(CLASS_1A inst) { NO_DELAY;
	mem_write(ext_RB(inst.rb), R(inst.rs_rd), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_RB_rs(CLASS_1A inst) { NO_DELAY;
	mem_write(ext_RB(inst.rb), R(inst.rs_rd), 4);
	PC += 2;
	CLK += 1;
}
static void exec_ld_b_rd_RBx(CLASS_1A inst) { NO_EXT; NO_DELAY;
	R(inst.rs_rd) = (char)mem_read(R(inst.rb), 1);
	R(inst.rb) += 1;
	PC += 2;
	CLK += 2;
}
static void exec_ld_ub_rd_RBx(CLASS_1A inst) { NO_EXT; NO_DELAY;
	R(inst.rs_rd) = (unsigned char)mem_read(R(inst.rb), 1);
	R(inst.rb) += 1;
	PC += 2;
	CLK += 2; /* ǂݍݑ[%rb]+2NbNv */
}
static void exec_ld_h_rd_RBx(CLASS_1A inst) { NO_EXT; NO_DELAY;
	R(inst.rs_rd) = (short)mem_read(R(inst.rb), 2);
	R(inst.rb) += 2;
	PC += 2;
	CLK += 2; /* ǂݍݑ[%rb]+2NbNv */
}
static void exec_ld_uh_rd_RBx(CLASS_1A inst) { NO_EXT; NO_DELAY;
	R(inst.rs_rd) = (unsigned short)mem_read(R(inst.rb), 2);
	R(inst.rb) += 2;
	PC += 2;
	CLK += 2; /* ǂݍݑ[%rb]+2NbNv */
}
static void exec_ld_w_rd_RBx(CLASS_1A inst) { NO_EXT; NO_DELAY;
	R(inst.rs_rd) = mem_read(R(inst.rb), 4);
	R(inst.rb) += 4;
	PC += 2;
	CLK += 2; /* ǂݍݑ[%rb]+2NbNv */
}
static void exec_ld_b_RBx_rs(CLASS_1A inst) { NO_EXT; NO_DELAY;
	mem_write(R(inst.rb), R(inst.rs_rd), 1);
	R(inst.rb) += 1;
	PC += 2;
	CLK += 1; /* ݑ[%rb]+1NbNōς */
}
static void exec_ld_h_RBx_rs(CLASS_1A inst) { NO_EXT; NO_DELAY;
	mem_write(R(inst.rb), R(inst.rs_rd), 2);
	R(inst.rb) += 2;
	PC += 2;
	CLK += 1; /* ݑ[%rb]+1NbNōς */
}
static void exec_ld_w_RBx_rs(CLASS_1A inst) { NO_EXT; NO_DELAY;
	mem_write(R(inst.rb), R(inst.rs_rd), 4);
	R(inst.rb) += 4;
	PC += 2;
	CLK += 1; /* ݑ[%rb]+1NbNōς */
}

/****************************************************************************
 *	CLASS 1B
 ****************************************************************************/

static void exec_add_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		R(inst.rd) = add(R(inst.rd), R(inst.rs));
	} else {
		R(inst.rd) = add(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_sub_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		R(inst.rd) = sub(R(inst.rd), R(inst.rs));
	} else {
		R(inst.rd) = sub(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_cmp_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		sub(R(inst.rd), R(inst.rs));
	} else {
		sub(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_rd_rs(CLASS_1B inst) { NO_EXT;
	R(inst.rd) = R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_and_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		R(inst.rd) = and(R(inst.rd), R(inst.rs));
	} else {
		R(inst.rd) = and(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_or_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		R(inst.rd) = or(R(inst.rd), R(inst.rs));
	} else {
		R(inst.rd) = or(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_xor_rd_rs(CLASS_1B inst) {
	if(!EXT1.s) {
		R(inst.rd) = xor(R(inst.rd), R(inst.rs));
	} else {
		R(inst.rd) = xor(R(inst.rs), ext_3op());
	}
	PC += 2;
	CLK += 1;
}
static void exec_not_rd_rs(CLASS_1B inst) { NO_EXT;
	R(inst.rd) = not(R(inst.rs));
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 2
 ****************************************************************************/

static void exec_ld_b_rd_SPxIMM6(CLASS_2 inst) { NO_DELAY;
	R(inst.rs_rd) = (char)mem_read(ext_SPxIMM6(inst.imm6, 1), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_ub_rd_SPxIMM6(CLASS_2 inst) { NO_DELAY;
	R(inst.rs_rd) = (unsigned char)mem_read(ext_SPxIMM6(inst.imm6, 1), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_h_rd_SPxIMM6(CLASS_2 inst) { NO_DELAY;
	R(inst.rs_rd) = (short)mem_read(ext_SPxIMM6(inst.imm6, 2), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_uh_rd_SPxIMM6(CLASS_2 inst) { NO_DELAY;
	R(inst.rs_rd) = (unsigned short)mem_read(ext_SPxIMM6(inst.imm6, 2), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_rd_SPxIMM6(CLASS_2 inst) { NO_DELAY;
	R(inst.rs_rd) = mem_read(ext_SPxIMM6(inst.imm6, 4), 4);
	PC += 2;
	CLK += 1;
}
static void exec_ld_b_SPxIMM6_rs(CLASS_2 inst) { NO_DELAY;
	mem_write(ext_SPxIMM6(inst.imm6, 1), R(inst.rs_rd), 1);
	PC += 2;
	CLK += 1;
}
static void exec_ld_h_SPxIMM6_rs(CLASS_2 inst) { NO_DELAY;
	mem_write(ext_SPxIMM6(inst.imm6, 2), R(inst.rs_rd), 2);
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_SPxIMM6_rs(CLASS_2 inst) { NO_DELAY;
	mem_write(ext_SPxIMM6(inst.imm6, 4), R(inst.rs_rd), 4);
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 3
 ****************************************************************************/

static void exec_add_rd_imm6(CLASS_3 inst) {
	R(inst.rd) = add(R(inst.rd), ext_imm6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}
static void exec_sub_rd_imm6(CLASS_3 inst) {
	R(inst.rd) = sub(R(inst.rd), ext_imm6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}
static void exec_cmp_rd_sign6(CLASS_3 inst) {
	sub(R(inst.rd), ext_sign6(inst.imm6_sign6)); /* vӁIimm6ł͂Ȃsign6łI */
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_rd_sign6(CLASS_3 inst) {
	R(inst.rd) = ext_sign6(inst.imm6_sign6);
	PC += 2;
	CLK += 1;
}
static void exec_and_rd_sign6(CLASS_3 inst) {
	R(inst.rd) = and(R(inst.rd), ext_sign6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}
static void exec_or_rd_sign6(CLASS_3 inst) {
	R(inst.rd) = or(R(inst.rd), ext_sign6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}
static void exec_xor_rd_sign6(CLASS_3 inst) {
	R(inst.rd) = xor(R(inst.rd), ext_sign6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}
static void exec_not_rd_sign6(CLASS_3 inst) {
	R(inst.rd) = not(ext_sign6(inst.imm6_sign6));
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 4A
 ****************************************************************************/

static void exec_add_sp_imm10(CLASS_4A inst) { NO_EXT;
	SP += inst.imm10 * 4;
	PC += 2;
	CLK += 1;
}
static void exec_sub_sp_imm10(CLASS_4A inst) { NO_EXT;
	SP -= inst.imm10 * 4;
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 4B
 ****************************************************************************/

static void exec_srl_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = srl(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_sll_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sll(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_sra_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sra(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_sla_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sla(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_rr_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = rr(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_rl_rd_imm4(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = rl(R(inst.rd), inst.imm4_rs);
	PC += 2;
	CLK += 1;
}
static void exec_srl_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = srl(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}
static void exec_sll_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sll(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}
static void exec_sra_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sra(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}
static void exec_sla_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = sla(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}
static void exec_rr_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = rr(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}
static void exec_rl_rd_rs(CLASS_4B inst) { NO_EXT;
	R(inst.rd) = rl(R(inst.rd), R(inst.imm4_rs));
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 4C
 ****************************************************************************/

static void exec_scan0_rd_rs(CLASS_4C inst) { NO_EXT;
	unsigned a = R(inst.rs);
	unsigned b;
	for(b = 0; b < 8; b++) {
		if(!(a & (1 << 31))) break;
		a <<= 1;
	}
	R(inst.rd) = b;
	PSR.z = b == 0;
	PSR.c = b == 8;
	PC += 2;
	CLK += 1;
}
static void exec_scan1_rd_rs(CLASS_4C inst) { NO_EXT;
	unsigned a = R(inst.rs);
	unsigned b;
	for(b = 0; b < 8; b++) {
		if(a & (1 << 31)) break;
		a <<= 1;
	}
	R(inst.rd) = b;
	PSR.z = b == 0;
	PSR.c = b == 8;
	PC += 2;
	CLK += 1;
}
static void exec_swap_rd_rs(CLASS_4C inst) { NO_EXT;
	unsigned a = R(inst.rs);
	R(inst.rd) = ((a & 0x000000ff) << 24) |
		     ((a & 0x0000ff00) <<  8) |
		     ((a & 0x00ff0000) >>  8) |
		     ((a & 0xff000000) >> 24);
	PC += 2;
	CLK += 1;
}
static void exec_mirror_rd_rs(CLASS_4C inst) { NO_EXT;
	unsigned a = R(inst.rs);
	R(inst.rd) = ((a & 0x01010101) << 7) |
		     ((a & 0x02020202) << 5) |
		     ((a & 0x04040404) << 3) |
		     ((a & 0x08080808) << 1) |
		     ((a & 0x10101010) >> 1) |
		     ((a & 0x20202020) >> 3) |
		     ((a & 0x40404040) >> 5) |
		     ((a & 0x80808080) >> 7);
	PC += 2;
	CLK += 1;
}
static void exec_div0s_rs(CLASS_4C inst) { NO_EXT; NO_DELAY;
	if(!R(inst.rs)) DIE()/*core_trap(TRAP_ZERODIV, 0)*/;
	AHR = (int)ALR >> 31;
	PSR.ds = ALR >> 31;
	PSR.n = R(inst.rs) >> 31;
	PC += 2;
	CLK += 1;
}
static void exec_div0u_rs(CLASS_4C inst) { NO_EXT; NO_DELAY;
	if(!R(inst.rs)) DIE()/*core_trap(TRAP_ZERODIV, 0)*/;
	AHR = 0;
	PSR.ds = 0;
	PSR.n = 0;
	PC += 2;
	CLK += 1;
}
static void exec_div1_rs(CLASS_4C inst) { NO_EXT; NO_DELAY;
	/* div0xȊOł́A[ZO͔܂B */
	unsigned tmp;
	AR <<= 1;
	if(!PSR.ds) {
		if(!PSR.n) { /*  */
			tmp = AHR - R(inst.rs);
			if(tmp <= AHR) { /* !C */
				AHR = tmp;
				ALR |= 1;
			}
		} else { /*  */
			tmp = AHR + R(inst.rs);
			if(tmp < AHR) { /* C */
				AHR = tmp;
				ALR |= 1;
			}
		}
	} else {
		if(!PSR.n) { /*  */
			tmp = AHR + R(inst.rs);
			if(tmp >= AHR) { /* !C */
				AHR = tmp;
				ALR |= 1;
			}
		} else { /*  */
			tmp = AHR - R(inst.rs);
			if(tmp > AHR) { /* !C */
				AHR = tmp;
				ALR |= 1;
			}
		}
	}
	PC += 2;
	CLK += 1;
}
static void exec_div2s_rs(CLASS_4C inst) { NO_EXT; NO_DELAY;
	/* div0xȊOł́A[ZO͔܂B */
	unsigned tmp;
	if(PSR.ds) {
		if(!PSR.n) {
			tmp = AHR + R(inst.rs);
		} else {
			tmp = AHR - R(inst.rs);
		}
		if(!tmp) {
			AHR = tmp;
			ALR += 1;
		}
	}
	PC += 2;
	CLK += 1;
}
static void exec_div3s(CLASS_4C inst) { NO_EXT; NO_DELAY;
	/* div0xȊOł́A[ZO͔܂B */
	if(PSR.ds != PSR.n) {
		ALR = 0 - ALR;	/* ALR = -ALR ł͌xɂȂ̂Łc */
	}
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 5A
 ****************************************************************************/

static void exec_ld_w_sd_rs(CLASS_5A inst) { NO_EXT; /*NO_DELAY; ̓fBCh\IEPSONCȕZ[`gĂ*/
	S(inst.sd_rd) = R(inst.rs_ss);
	PC += 2;
	CLK += 1;
}
static void exec_ld_w_rd_ss(CLASS_5A inst) { NO_EXT; /*NO_DELAY; ̓fBCh\IEPSONCȕZ[`gĂ*/
	R(inst.sd_rd) = S(inst.rs_ss);
	PC += 2;
	CLK += 1;
}

/****************************************************************************
 *	CLASS 5B
 ****************************************************************************/

static void exec_btst_RB_imm3(CLASS_5B inst) { NO_DELAY;
	PSR.z = !((mem_read(ext_RB(inst.rb), 1) >> inst.imm3) & 1);
	PC += 2;
	CLK += 3;
}
static void exec_bclr_RB_imm3(CLASS_5B inst) { NO_DELAY;
	unsigned addr = ext_RB(inst.rb);
	mem_write(addr, mem_read(addr, 1) & ~(1 << inst.imm3), 1);
	PC += 2;
	CLK += 3;
}
static void exec_bset_RB_imm3(CLASS_5B inst) { NO_DELAY;
	unsigned addr = ext_RB(inst.rb);
	mem_write(addr, mem_read(addr, 1) | (1 << inst.imm3), 1);
	PC += 2;
	CLK += 3;
}
static void exec_bnot_RB_imm3(CLASS_5B inst) { NO_DELAY;
	unsigned addr = ext_RB(inst.rb);
	mem_write(addr, mem_read(addr, 1) ^ (1 << inst.imm3), 1);
	PC += 2;
	CLK += 3;
}

/****************************************************************************
 *	CLASS 5C
 ****************************************************************************/

static void exec_adc_rd_rs(CLASS_5C inst) { NO_EXT;
	R(inst.rd) = adc(R(inst.rd), R(inst.rs));
	PC += 2;
	CLK += 1;
}
static void exec_sbc_rd_rs(CLASS_5C inst) { NO_EXT;
	R(inst.rd) = sbc(R(inst.rd), R(inst.rs));
	PC += 2;
	CLK += 1;
}
static void exec_ld_b_rd_rs(CLASS_5C inst) { NO_EXT; NO_DELAY; /*vӁIfBChsI*/
	R(inst.rd) = (char)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_ld_ub_rd_rs(CLASS_5C inst) {  NO_EXT; NO_DELAY; /*vӁIfBChsI*/
	R(inst.rd) = (unsigned char)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_ld_h_rd_rs(CLASS_5C inst) {  NO_EXT; NO_DELAY; /*vӁIfBChsI*/
	R(inst.rd) = (short)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_ld_uh_rd_rs(CLASS_5C inst) {  NO_EXT; NO_DELAY; /*vӁIfBChsI*/
	R(inst.rd) = (unsigned short)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_mlt_h_rd_rs(CLASS_5C inst) { NO_EXT;
	ALR = (short)R(inst.rd) * (short)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_mltu_h_rd_rs(CLASS_5C inst) { NO_EXT;
	ALR = (unsigned short)R(inst.rd) * (unsigned short)R(inst.rs);
	PC += 2;
	CLK += 1;
}
static void exec_mlt_w_rd_rs(CLASS_5C inst) { NO_EXT; NO_DELAY;
	AR = (int64)(int)R(inst.rd) * (int64)(int)R(inst.rs);
	PC += 2;
	CLK += 5;
}
static void exec_mltu_w_rd_rs(CLASS_5C inst) { NO_EXT; NO_DELAY;
	AR = (uint64)(unsigned)R(inst.rd) * (uint64)(unsigned)R(inst.rs);
	PC += 2;
	CLK += 5;
}
static void exec_mac_rs(CLASS_5C inst) { NO_EXT; NO_DELAY;
	//int64 a, b, c;
	//while(R(inst.rs) != 0) {
	//	a = AR;
	//	b = (short)mem_read(R(inst.rs + 1), 2) * (short)mem_read(R(inst.rs + 2), 2);
	//	c = a + b;
	//	AR = a;
	//	if(!PSR.mo) { /* 10ɂ͕ωȂ */
	//		PSR.mo = (a < 0  && b <  0 && c >= 0) ||
	//		         (a >= 0 && b >= 0 && c <  0);
	//	}
	//	R(inst.rs)--;
	//	R(inst.rs + 1) += 2;
	//	R(inst.rs + 2) += 2;
	//	CLK += 2;
	//}
	//PC += 2;
	//CLK += 4;
	//
	//{͂łAmacߎsɊ荞݂󂯕t邽߂ɁÂ悤ɕύX܂B
	//@ƈႢmac߂tFb`Ă܂߁A@sTCNĂ܂B
	//
	int64 a, b, c;
	if(R(inst.rs)) {
		a = AR;
		b = (short)mem_read(R(inst.rs + 1), 2) * (short)mem_read(R(inst.rs + 2), 2);
		c = a + b;
		AR = a;
		if(!PSR.mo) { /* 10ɂ͕ωȂ */
			PSR.mo = (a < 0  && b <  0 && c >= 0) ||
			         (a >= 0 && b >= 0 && c <  0);
		}
		R(inst.rs)--;
		R(inst.rs + 1) += 2;
		R(inst.rs + 2) += 2;
		/* PC͂̂܂܁Bmac߂s܂B */
		CLK += 2;
	} else {
		PC += 2;
		CLK += 4;
	}
}

/****************************************************************************
 *	CLASS 6
 ****************************************************************************/

static void exec_ext_imm13(CLASS_6 inst) { NO_DELAY;
	INST inst2;

	if(!EXT1.s) {
		EXT1.c6 = inst;
	} else if(!EXT2.s) {
		EXT2.c6 = inst;
	} else {
		DIE();
	}
	PC += 2;
	CLK += 1;

	/* g閽߂sBi̊Ԃ̊荞݂֎~邽߁j */
	inst2.s = mem_read(PC, 2);
	core_inst(inst2);
	if(EXT1.s) DIE(); /* mextĂ邱 */
}

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

void
core_init()
{
	memset(&core, 0, sizeof core);
	PC = mem_read(0x0c00000, 4);
}

void
core_work()
{
	INST inst;
	inst.s = mem_read(PC, 2);
	core_inst(inst);
}

void
core_trap(int no, int level)
{
	unsigned addr;

	/* }XN\Ȋ荞݂̏ꍇ̂݁A荞݉\܂B */
	if(no >= 16) {
		if(!PSR.ie) return;
		if((unsigned)level <= PSR.il) return;
	}

	addr = mem_read(pTTBR_REG + no * 4, 4);	/* v:gbve[uǂ݂Ă܂ */
	SP -= 4;
	mem_write(SP, PC, 4); /* vӁIPC+2ȂI */
	SP -= 4;
	mem_write(SP, S(0), 4);
	PC = addr;
	PSR.ie = 0;

	/* }XN\Ȋ荞݂̏ꍇ̂݁A荞݃xω܂B */
	if(no >= 16) {
		PSR.il = level;
	}
}

void
core_inst(INST inst)
{
	switch(inst.c0a.cls) {
	case 0:
		switch(inst.c0a.op1) {
		/* CLASS 0A */
		case  0:
			switch(inst.c0a.op2) {
			case 0: exec_nop(inst.c0a); return;
			case 1: exec_slp(inst.c0a); return;
			case 2: exec_halt(inst.c0a); return;
			}
			break;
		case  1:
			switch(inst.c0a.op2) {
			case 0: exec_pushn_rs(inst.c0a); return;
			case 1: exec_popn_rd(inst.c0a); return;
			}
			break;
		case  2:
			switch(inst.c0a.op2) {
			case 0: exec_brk(inst.c0a); return;
			case 1: exec_retd(inst.c0a); return;
			case 2: exec_int_imm2(inst.c0a); return;
			case 3: exec_reti(inst.c0a); return;
			}
			break;
		case  3:
			switch(inst.c0a.op2) {
			case 0: exec_call_rb(inst.c0a); return;
			case 1: exec_ret(inst.c0a); return;
			case 2: exec_jp_rb(inst.c0a); return;
			}
			break;
		/* CLASS 0B */
		case  4: exec_jrgt_sign8(inst.c0b); return;
		case  5: exec_jrge_sign8(inst.c0b); return;
		case  6: exec_jrlt_sign8(inst.c0b); return;
		case  7: exec_jrle_sign8(inst.c0b); return;
		case  8: exec_jrugt_sign8(inst.c0b); return;
		case  9: exec_jruge_sign8(inst.c0b); return;
		case 10: exec_jrult_sign8(inst.c0b); return;
		case 11: exec_jrule_sign8(inst.c0b); return;
		case 12: exec_jreq_sign8(inst.c0b); return;
		case 13: exec_jrne_sign8(inst.c0b); return;
		case 14: exec_call_sign8(inst.c0b); return;
		case 15: exec_jp_sign8(inst.c0b); return;
		}
		break;
	case 1:
		switch(inst.c1a.op2) {
		/* CLASS 1A */
		case  0:
			switch(inst.c1a.op1) {
			case 0: exec_ld_b_rd_RB(inst.c1a); return;
			case 1: exec_ld_ub_rd_RB(inst.c1a); return;
			case 2: exec_ld_h_rd_RB(inst.c1a); return;
			case 3: exec_ld_uh_rd_RB(inst.c1a); return;
			case 4: exec_ld_w_rd_RB(inst.c1a); return;
			case 5: exec_ld_b_RB_rs(inst.c1a); return;
			case 6: exec_ld_h_RB_rs(inst.c1a); return;
			case 7: exec_ld_w_RB_rs(inst.c1a); return;
			}
			break;
		case  1:
			switch(inst.c1a.op1) {
			case 0: exec_ld_b_rd_RBx(inst.c1a); return;
			case 1: exec_ld_ub_rd_RBx(inst.c1a); return;
			case 2: exec_ld_h_rd_RBx(inst.c1a); return;
			case 3: exec_ld_uh_rd_RBx(inst.c1a); return;
			case 4: exec_ld_w_rd_RBx(inst.c1a); return;
			case 5: exec_ld_b_RBx_rs(inst.c1a); return;
			case 6: exec_ld_h_RBx_rs(inst.c1a); return;
			case 7: exec_ld_w_RBx_rs(inst.c1a); return;
			}
			break;
		/* CLASS 1B */
		case  2:
			switch(inst.c1a.op1) {
			case 0: exec_add_rd_rs(inst.c1b); return;
			case 1: exec_sub_rd_rs(inst.c1b); return;
			case 2: exec_cmp_rd_rs(inst.c1b); return;
			case 3: exec_ld_w_rd_rs(inst.c1b); return;
			case 4: exec_and_rd_rs(inst.c1b); return;
			case 5: exec_or_rd_rs(inst.c1b); return;
			case 6: exec_xor_rd_rs(inst.c1b); return;
			case 7: exec_not_rd_rs(inst.c1b); return;
			}
			break;
		}
		break;
	case 2:
		switch(inst.c2.op1) {
		/* CLASS 2 */
		case 0: exec_ld_b_rd_SPxIMM6(inst.c2); return;
		case 1: exec_ld_ub_rd_SPxIMM6(inst.c2); return;
		case 2: exec_ld_h_rd_SPxIMM6(inst.c2); return;
		case 3: exec_ld_uh_rd_SPxIMM6(inst.c2); return;
		case 4: exec_ld_w_rd_SPxIMM6(inst.c2); return;
		case 5: exec_ld_b_SPxIMM6_rs(inst.c2); return;
		case 6: exec_ld_h_SPxIMM6_rs(inst.c2); return;
		case 7: exec_ld_w_SPxIMM6_rs(inst.c2); return;
		}
		break;
	case 3:
		switch(inst.c3.op1) {
		/* CLASS 3 */
		case 0: exec_add_rd_imm6(inst.c3); return;
		case 1: exec_sub_rd_imm6(inst.c3); return;
		case 2: exec_cmp_rd_sign6(inst.c3); return;
		case 3: exec_ld_w_rd_sign6(inst.c3); return;
		case 4: exec_and_rd_sign6(inst.c3); return;
		case 5: exec_or_rd_sign6(inst.c3); return;
		case 6: exec_xor_rd_sign6(inst.c3); return;
		case 7: exec_not_rd_sign6(inst.c3); return;
		}
		break;
	case 4:
		switch(inst.c4a.op1) {
		/* CLASS 4A */
		case 0: exec_add_sp_imm10(inst.c4a); return;
		case 1: exec_sub_sp_imm10(inst.c4a); return;
		default:
			switch(inst.c4b.op2) {
			/* CLASS 4B */
			case 0:
				switch(inst.c4b.op1) {
				case 2: exec_srl_rd_imm4(inst.c4b); return;
				case 3: exec_sll_rd_imm4(inst.c4b); return;
				case 4: exec_sra_rd_imm4(inst.c4b); return;
				case 5: exec_sla_rd_imm4(inst.c4b); return;
				case 6: exec_rr_rd_imm4(inst.c4b); return;
				case 7: exec_rl_rd_imm4(inst.c4b); return;
				}
				break;
			case 1:
				switch(inst.c4b.op1) {
				case 2: exec_srl_rd_rs(inst.c4b); return;
				case 3: exec_sll_rd_rs(inst.c4b); return;
				case 4: exec_sra_rd_rs(inst.c4b); return;
				case 5: exec_sla_rd_rs(inst.c4b); return;
				case 6: exec_rr_rd_rs(inst.c4b); return;
				case 7: exec_rl_rd_rs(inst.c4b); return;
				}
				break;
			/* CLASS 4C */
			case 2:
				switch(inst.c4c.op1) {
				case 2: exec_scan0_rd_rs(inst.c4c); return;
				case 3: exec_scan1_rd_rs(inst.c4c); return;
				case 4: exec_swap_rd_rs(inst.c4c); return;
				case 5: exec_mirror_rd_rs(inst.c4c); return;
				}
				break;
			case 3:
				switch(inst.c4c.op1) {
				case 2: exec_div0s_rs(inst.c4c); return;
				case 3: exec_div0u_rs(inst.c4c); return;
				case 4: exec_div1_rs(inst.c4c); return;
				case 5: exec_div2s_rs(inst.c4c); return;
				case 6: exec_div3s(inst.c4c); return;
				}
				break;
			}
			break;
		}
		break;
	case 5:
		switch(inst.c5a.op2) {
		case 0:
			switch(inst.c5a.op1) {
			/* CLASS 5A */
			case 0: exec_ld_w_sd_rs(inst.c5a); return;
			case 1: exec_ld_w_rd_ss(inst.c5a); return;
			/* CLASS 5B */
			case 2: exec_btst_RB_imm3(inst.c5b); return;
			case 3: exec_bclr_RB_imm3(inst.c5b); return;
			case 4: exec_bset_RB_imm3(inst.c5b); return;
			case 5: exec_bnot_RB_imm3(inst.c5b); return;
			/* CLASS 5C */
			case 6: exec_adc_rd_rs(inst.c5c); return;
			case 7: exec_sbc_rd_rs(inst.c5c); return;
			}
			break;
		case 1:
			switch(inst.c5c.op1) {
			case 0: exec_ld_b_rd_rs(inst.c5c); return;
			case 1: exec_ld_ub_rd_rs(inst.c5c); return;
			case 2: exec_ld_h_rd_rs(inst.c5c); return;
			case 3: exec_ld_uh_rd_rs(inst.c5c); return;
			}
			break;
		case 2:
			switch(inst.c5c.op1) {
			case 0: exec_mlt_h_rd_rs(inst.c5c); return;
			case 1: exec_mltu_h_rd_rs(inst.c5c); return;
			case 2: exec_mlt_w_rd_rs(inst.c5c); return;
			case 3: exec_mltu_w_rd_rs(inst.c5c); return;
			case 4: exec_mac_rs(inst.c5c); return;
			}
			break;
		}
		break;
	case 6:
		/* CLASS 6 */
		exec_ext_imm13(inst.c6); return;
		break;
	}
	DIE();
}

