/*	
 *	emu.c
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

EMU emu;

/****************************************************************************
 *	W[`
 ****************************************************************************/

typedef struct _MODULE {
	void (*init)();
	void (*work)();
} MODULE;
#define MOD(m)	{ m##_init, m##_work },
static MODULE module_tbl[] = {
	MOD(fram)
	MOD(iomem)
	MOD(sram)
	MOD(usbc)
	MOD(flash)
	MOD(lcdc)
	MOD(bcu)
	/* core͊܂߂Ȃ */
};
#undef MOD
#define MODULE_COUNT	(sizeof module_tbl / sizeof *module_tbl)

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

void
emu_init()
{
	int retval, i;
	MODULE* module;

	memset(&emu, 0, sizeof emu);

	/*{{P/ECEɐڑ:*/
	retval = ismInit();
	if(retval) die("P/ECEɐڑł܂B");
	retval = ismGetVersion(&emu.sysinfo, 1);
	if(retval == PIECE_INVALID_VERSION) DIE();
	printf("BIOS version = %d.%02d\n", retval>>8, retval&255);
	printf("BIOS date    = %d.%02d.%02d\n", 2000+(emu.sysinfo.bios_date>>9), (emu.sysinfo.bios_date>>5)&15, emu.sysinfo.bios_date&31);
	printf("SRAM top adr = 0x%x\n", emu.sysinfo.sram_top);
	printf("SRAM end adr = 0x%x\n", emu.sysinfo.sram_end-1);
	printf("SRAM size    = %d KB\n", (emu.sysinfo.sram_end - emu.sysinfo.sram_top)>>10);
	printf("HW version   = %d.%02d\n", emu.sysinfo.hard_ver>>8, emu.sysinfo.hard_ver&255);
	printf("SYSTEM clock = %5.3f MHz\n", emu.sysinfo.sys_clock / 1e6);
	printf("VDDE voltage = %5.3f V\n", emu.sysinfo.vdde_voltage / 1e3);
	printf("PFFS top adr = 0x%x\n", emu.sysinfo.pffs_top);
	printf("PFFS end adr = 0x%x\n", emu.sysinfo.pffs_end-1);

	/* eW[̏B */
	for(i = 0, module = module_tbl; i < MODULE_COUNT; i++, module++) {
		if(module->init) module->init();
	}
	core_init(); /* ̒瑼̃W[ĝŁAŌɏ */

	retval = ismExit();
	/*}}P/ECEɐڑ:܂*/

	/* ^C~Oϐ̏lݒB */
	emu.clk_save = core.clk;
	emu.tick_save = GetTickCount();
}

void
emu_work()
{
#define MILS		(SYSTEM_CLOCK / 1000)
#define UPD_ITV		(1000 / (180 / 3))	/* t[g180Hz1/3=60HzōXV */

	int i, tick, dt;
	MODULE* module;

	do {
		core_work();

		/*{{*/
		pCLK_TCD++;
		/*}}*/
	} while(CLK - emu.clk_save < MILS); /* 1~b̏ */
	emu.clk_save += MILS;

	/* vӁI
	 * KAW[NMȈōsĂI
	 * ȂƁAW[̊荞ݔsNMIɃubNĂ܂܂B
	 */

	/* eW[̏B */
	for(i = 0, module = module_tbl; i < MODULE_COUNT; i++, module++) {
		if(module->work) module->work();
	}

	/* P/ECEVXe^C}pNMIB */
	if(bWD_EN_EWD) core_trap(TRAP_NMI, 0);

	/* ԂƂ̓B */
	for(;;) {
		tick = GetTickCount();
		dt = tick - emu.tick_save;
		if(dt >= 1/*1msȏo߂ĂH*/) break;
	}
	emu.tick_save += 1;
	if(tick - emu.tick_save > 10) emu.tick_save = tick - 10; /* Ԃ10msȏ͒x点Ȃ */

	emu.upd_cnt++;
	if(emu.upd_cnt >= UPD_ITV) {
		lcdc_conv(vbuff);
		InvalidateRect(hwnd, NULL, 0);
		UpdateWindow(hwnd);
		emu.upd_cnt -= UPD_ITV;
	}
}

