/*	
 *	iomem.c
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 *	* Wed Apr 22 00:00:00 JST 2003 Naoyuki Sawa
 *	- TEhΉBirj
 *	* Wed Apr 22 05:37:00 JST 2003 Naoyuki Sawa
 *	- muslib̃mCYB(TEh荞݂̃x)
 */
#include "app.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

IOMEM iomem;

/****************************************************************************
 *	I/O}bv`
 ****************************************************************************/

#define IOMAP_TBL
#include "iomap.h"
#undef IOMAP_TBL

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

void
iomem_init()
{
	int retval;
	WAVEFORMATEX wfx;

	memset(&iomem, 0, sizeof iomem);

	/* LCDC */
	bSIF3_STATUS_TDBE3 = 1; /* ɓ]f[^obt@GveB */

	/* SOUND */
	memset(&wfx, 0, sizeof wfx);
	wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = 1;
	wfx.nSamplesPerSec = 32000;
	wfx.nAvgBytesPerSec = 32000 * sizeof(short);
	wfx.nBlockAlign = sizeof(short);
	wfx.wBitsPerSample = 8 * sizeof(short);
	retval = waveOutOpen(&iomem.hwo, WAVE_MAPPER, &wfx, 0, 0, CALLBACK_NULL);
	if(retval != 0) DIE();
}

static IOMAP*
iomap_sel(unsigned ofs)
{
	int i;
	IOMAP* iomap;
	/* ĂяoŁuofs &= IOMEM_SIZE - 1;vĂƁB */
	for(i = 0, iomap = iomap_tbl; i < IOMAP_COUNT; i++, iomap++) {
		if(ofs == IOOFS(iomap->addr)) return iomap;
	}
	return NULL;
}

int
iomem_read(unsigned ofs, int size)
{
	IOMAP* iomap;

	ofs &= IOMEM_SIZE - 1; /* Kv */

	/* nhB */
	iomap = iomap_sel(ofs);
	if(iomap && iomap->read) {
		return iomap->read(ofs, size);
	}

	/* nhȂ΁Aiomem.mem[]PɓǂݏoB */
	dbg("ΉI/Oǂݏo: %07x", ofs);
	return iomem_read_default(ofs, size);
}

/* iomem.mem[]̓ǂݏoBeI/Onhp\łB */
int
iomem_read_default(unsigned ofs, int size)
{
	int data = 0;
	if(ofs & ~(IOMEM_SIZE - 1)) DIE();
	memcpy(&data, &iomem.mem[ofs], size);
	return data;
}

void
iomem_write(unsigned ofs, int data, int size)
{
	IOMAP* iomap;

	ofs &= IOMEM_SIZE - 1; /* Kv */

	/* nhB */
	iomap = iomap_sel(ofs);
	if(iomap && iomap->write) {
		iomap->write(ofs, data, size);
		return;
	}

	/* nhȂ΁Aiomem.mem[]ɒPɏށB */
	dbg("ΉI/O: %07x", ofs);
	iomem_write_default(ofs, data, size);
}

/* iomem.mem[]ւ̏݁BeI/Onhp\łB */
void
iomem_write_default(unsigned ofs, int data, int size)
{
	if(ofs & ~(IOMEM_SIZE - 1)) DIE();
	memcpy(&iomem.mem[ofs], &data, size);
}

/****************************************************************************
 *	I/Onh
 ****************************************************************************/

IOR_(pK5_K5D) {
	int data = -1;
	if(keystate[KEY_SELECT]) data &= ~(1 << 3); /* SELECT */
	if(keystate[KEY_START ]) data &= ~(1 << 4); /* START  */
	return data;
}

IOR_(pK6_K6D) {
	int data = -1;
	if(keystate[KEY_RIGHT]) data &= ~(1 << 0);
	if(keystate[KEY_LEFT ]) data &= ~(1 << 1);
	if(keystate[KEY_DOWN ]) data &= ~(1 << 2);
	if(keystate[KEY_UP   ]) data &= ~(1 << 3);
	if(keystate[KEY_B    ]) data &= ~(1 << 4); /* B */
	if(keystate[KEY_A    ]) data &= ~(1 << 5); /* A */
	return data;
}

/*
 1f5	pSIF3_TXD
 1f8	pSIF3_CTL	default
 2d9	pP2_P2D		default
8220	pHS0_CNT	default
8224	pHS0_SADR	default
8228	pHS0_DADR	default
822c	pHS0_EN		default
822e	pHS0_TF		default
*/

IO_W(pSIF3_TXD) {
	for(;;) {
		lcdc_write((unsigned char)data);		/* VACh.3f[^LCDC */
		if(!bHS0_EN_HS0EN) break;			/* HSDMA Ch.0~Ȃ甲 */
		data = mem_read_nowait(bHS0_SADR_S0ADR, 1);	/* ̃f[^擾 */
		bHS0_SADR_S0ADR++;				/* ]AhXi߂ */
		if(!--bHS0_CNT_SIG_TC0) bHS0_EN_HS0EN = 0;	/* ]JE^炵A0ɂȂDMA~ */
	}
}

IO_W(pHS1_EN) {
	int retval, i, en_save, buflen;
	short v, *p;
	WAVEHDR* wh;

	/* HSDMA1Cl[urbg̏݁B */
	en_save = bHS1_EN_HS1EN;
	iomem_write_default(ofs, data, size);
	if(bHS1_EN_HS1EN == en_save) return; /* DISABLEDISABLE or ENABLEENABLE */
	if(!bHS1_EN_HS1EN) { /* ENABLEDISABLE */
		retval = waveOutReset(iomem.hwo);
		if(retval != 0) DIE();
		for(i = 0, wh = iomem.wh; i < BLKN; i++, wh++) {
			if(wh->dwFlags & WHDR_PREPARED) {
				retval = waveOutUnprepareHeader(iomem.hwo, wh, sizeof(WAVEHDR));
				if(retval != 0) DIE();
				wh->dwFlags = 0;
			}
		}
		return;
	}
	/* ȉADISABLEENABLE */

	/* 󂫃obt@T܂B */
	for(i = 0, wh = iomem.wh; i < BLKN; i++, wh++) {
		if(!(wh->dwFlags & WHDR_PREPARED)) break;
	}
	if(i == BLKN) DIE();

	/* Kvɉăobt@gB */
	buflen = bHS1_CNT_SIG_TC1 * sizeof(short);
	if((int)wh->dwBufferLength < buflen) {
		wh->lpData = realloc(wh->lpData, buflen);
		if(!wh->lpData) DIE();
	}
	wh->dwBufferLength = buflen;

	/* EF[uf[^ϊB */
	p = (short*)wh->lpData;
	do {
		v = (short)mem_read_nowait(bHS1_SADR_S1ADR, 2);	/*      0`750` 1500 */
		v = v - 750;					/*   -750`  0`  750 */
		v = v * 32767 / 750;				/* -32767`  0`32767 */
		*p++ = v;
		bHS1_SADR_S1ADR += 2;
	} while(--bHS1_CNT_SIG_TC1);

	wh->dwFlags = 0;

	/* obt@bNāAJnB */
	retval = waveOutPrepareHeader(iomem.hwo, wh, sizeof(WAVEHDR));
	if(retval != 0) DIE();
	retval = waveOutWrite(iomem.hwo, wh, sizeof(WAVEHDR));
	if(retval != 0) DIE();
}

void
iomem_work()
{
	int retval, i;
	WAVEHDR* wh;

	/* obt@AbNB */
	for(i = 0, wh = iomem.wh; i < BLKN; i++, wh++) {
		if(wh->dwFlags & WHDR_DONE) {
			retval = waveOutUnprepareHeader(iomem.hwo, wh, sizeof(WAVEHDR));
			if(retval != 0) DIE();
			wh->dwFlags = 0;
		}
		/* HSDMA1쒆ŁA󂫃obt@΁AHSDMA1]ƌȂĊ荞ݗvB */
		if(bHS1_EN_HS1EN && !wh->dwFlags) {
			bHS1_EN_HS1EN = 0;
			bINT_FDMA_FHDM1 = 1;
		}
	}

	/* HSDMA1荞݂ĂāA荞ݗvĂA荞ݔsB */
	if(bINT_EDMA_EHDM1 && bINT_FDMA_FHDM1) {
		//core_trap(TRAP_HDM1, bINT_PHSD01L_PHSD1L);
		//{͂ł...
		//@P/ECEJ[l̃TEhhCo͑d荞݂Ă̂łA
		//@TEh(IL=5őd荞ݎt)ɃTEh̊荞(IL=7Ȃ̂Ŋ荞݉\)ƁA
		//@mCYɂȂ悤łB
		//@ʏWaveĐȂŷőv݂łǁAmuslibɂBGMĐŃmCY܂܂B
		//muslib̃mCYh߂ɁA@KIɃTEh̊荞݃xĂ݂܂B
		//@{̃J[lłATEh̃TEh荞ݎ󂯕t͂Ȃ悳ȋCc(^^;
		core_trap(TRAP_HDM1, 1/*5ȉȂȂłǁAƂ肠荞݉\ȍŒ჌xɂĂ݂*/);
	}
}
